#include "tests/ThreadTests.h"

#include "test/Test.h"
#include "thread/Thread.h"

static int runDone = 0;

struct IntHolder {
    int value;
};

static int run(void*) {
    runDone = 1;
    return 7;
}

static void testStart() {
    runDone = 0;
    Core::Thread::Id id = Core::Thread::start(run, nullptr);
    CORE_TEST_FALSE(id == Core::Thread::ERROR);
    int returnValue = 0;
    CORE_TEST_FALSE(Core::Thread::join(id, &returnValue));
    CORE_TEST_EQUAL(1, runDone);
    CORE_TEST_EQUAL(7, returnValue);
}

static void testLambda() {
    IntHolder i(0);
    Core::Thread::Id id = Core::Thread::start(
        [](void* p) {
            IntHolder* ip = static_cast<IntHolder*>(p);
            ip->value = 2;
            return 0;
        },
        &i);
    CORE_TEST_FALSE(id == Core::Thread::ERROR);
    CORE_TEST_FALSE(Core::Thread::join(id, nullptr));
    CORE_TEST_EQUAL(2, i.value);
}

void Core::ThreadTests::test() {
    testStart();
    testLambda();
}