#ifndef CORE_THREAD_H
#define CORE_THREAD_H

#include "utils/Check.h"

namespace Core::Thread {
    using Id = int;
    constexpr Id ERROR = -1;
    using Function = int (*)(void*);
    // returns Core::Thread::ERROR on error and calls the error callback
    check_return Id start(Function f, void* p);
    // returns true on error and calls the error callback
    check_return bool join(Id id, int* returnValue = nullptr);
}

#endif